import geomerative.*;        // Library importieren
import processing.serial.*;

RShape grp;                  // Hierdrin ist die Vektorgrafik gespeichert. Rshape ist der Variablentyp/Klasse
RPoint[][] pointPaths;       // Darin werden die einzelnen Punkte gespeichert. 

float xmag, ymag, newYmag, newXmag = 0;    // irgendwelche Größen, wahrscheinlich irrelevant
float z = 0;                               // float

boolean ignoringStyles = false;            // weiß Felix auch nicht

float faktor;

void setup(){
  lauf = 0;
  // VERY IMPORTANT: Allways initialize the library before using it
  RG.init(this);
  RG.ignoreStyles(ignoringStyles);
  
  RG.setPolygonizer(RG.ADAPTATIVE);        // bestimmt, dass der Winkel zwischen 3 aufeinander folgenden Punkten nicht zu spitz wird
  
  grp = RG.loadShape("rechteseck.svg");          // lädt Datei (data Ordner)
  grp.centerIn(g, 100, 1, 1);              // zentriert Grafik
  
  pointPaths = grp.getPointsInPaths();     // wandelt Vektorgrafik aus grp in einzelne Punkte um und speichert in pointPaths
  
 
  String portName = Serial.list()[Serial.list().length-1];
  int baudrate=9600;
  myPort = new Serial(this, portName, baudrate);
  
  float rand;
  float breite = grp.getBoundsPoints()[1].x - grp.getBoundsPoints()[0].x;
  float hoehe = grp.getBoundsPoints()[2].y - grp.getBoundsPoints()[1].y;
  if (breite < hoehe) {
    rand = hoehe;
    println("select hoehe");
  } else {
    rand = breite;
    println("select breite");
  }
  print("breite: ");
  println(breite);
  print("hoehe: ");
  println(hoehe);
  faktor = 30/rand;
  println(faktor);
  

}

Serial myPort;
int lauf;
void draw(){
  
  if(lauf == 0){
  
  

  
  
  for(int i = 0; i<pointPaths.length; i++){          // geht Anzahl der in der Vektorgrafik existierenden Linien durch
   
    if (pointPaths[i] != null) {                     // falls die Linie Punkte enthält
     
      println("-------------------------------new objekt---------------------------");
      float x = pointPaths[i][0].x;                  // Während die Spritze aus ist bewegt ElChoc sich zum ersten Punkt der nächsten Figure
      float y = pointPaths[i][0].y;
      x *= faktor;                                   // mal faktor oder durch faktor??? 
      y *= faktor;
      //myPort.write('x'+str(x));
      println(x);
      //myPort.write('y'+str(y));
      println(y);
      
      //myPort.write('v'+'1');                      // die Spritze geht wieder an
      println("AAAUUUUUUUUUUFF");
      
      delay(100);
      for(int j = 1; j<pointPaths[i].length; j++){   // gehe alle Punkte in der Linie durch
      
        x = pointPaths[i][j].x;
        y = pointPaths[i][j].y;
        x *= faktor;
        y *= faktor;
        //myPort.write('x'+str(x));
        //myPort.write('y'+str(y));
        println(x);
        println(y);
        delay(10);
      }
      //myPort.write('v'+'0');                      // Spritze geht am Ende der Figur aus
      println("ZZZUUUUUUUUU");
    }
  }
  }
  lauf++;
  
}